/*---------------------------------------------------------------------------------

	>> INSTITUT INFORMACNICH TECHNOLOGII
	>> FAKULTA TECHNOLOGICKA
	>> UNIVERZITA TOMASE BATI VE ZLINE					       
 
	Soubor	:	CCircle.h
	Popis	:	Rasterizace kruznice
	Autor	:	Jan Stalmach, stalmachjan@volny.cz 
	Obor	:	Informacni technologie, 2003-2004
	  
	Implementovany nasledujci algoritmy:
	
	Bresenhamuv kruznicovy interpolator
	Rotace bodu kolem stredu kruznice
	Algoritmus kresleni kruznice pomoci parametrickeho tvaru (DDA)
	
----------------------------------------------------------------------------------*/

#ifndef _CIRCLE_H	
#define _CIRCLE_H	


#include "CRaster.h"
#include "stopky.h"
#include "CLine.h"


// Pi na 9 desetinnych mist
#define PI 3.141592654


/*----------------------------------------------
	Trida CCircle
------------------------------------------------*/
class CCircle: public CRaster {

protected:

	Stopky *Casovac;
	float red,green,blue;

public:

	CCircle(float r, float g, float b);

	~CCircle() {}

	CLine  *Cara;

	double Bresenham(int x, int y, int polomer);
	double Parametricky_tvar(int x, int y, int polomer);
    double Rotace(int x, int y, int polomer);
    
	void Set_RGB(float r, float g, float b);

};


#endif