/*---------------------------------------------------------------------------------

	>> INSTITUT INFORMACNICH TECHNOLOGII
	>> FAKULTA TECHNOLOGICKA
	>> UNIVERZITA TOMASE BATI VE ZLINE					       
 
	Soubor	:	CElipse.h
	Popis	:	Rasterizace elipsy
	Autor	:	Jan Stalmach, stalmachjan@volny.cz 
	Obor	:	Informacni technologie, 2003-2004
	
	Implementovany nasledujci algoritmy:

	Bresenhamuv algoritmus pro kreleni elipsy
	Algoritmus vyuzivajici parametrickeho vyjadreni eplipsy
	Elipsa v obecne poloze

----------------------------------------------------------------------------------*/

#ifndef _ELIPSE_H	
#define _ELIPSE_H	

#include "CRaster.h"
#include "stopky.h"

// Pi na 9 desetinnych mist
#define PI 3.141592654
#define RAD(x) (x * 3.1415926536 / 180)		  // Definuje funkci RAD 

/*----------------------------------------------
 Trida CElipse pro rasterizaci elipsy
------------------------------------------------*/
class CElipse: public CRaster {

protected:

	Stopky *Casovac;

	float red,green,blue;

public:

	CElipse(float r, float g, float b);
	~CElipse() {}

	double Bresenham(int x0, int y0, int a, int b);
	double Parametricky_tvar(int x, int y, int a, int b);
	double Obecna_poloha(int x0, int y0, int a, int b, int uhel);
	
	void Set_RGB(float r, float g, float b);

};

#endif