/*---------------------------------------------------------------------------------

	>> INSTITUT INFORMACNICH TECHNOLOGII
	>> FAKULTA TECHNOLOGICKA
	>> UNIVERZITA TOMASE BATI VE ZLINE					       
 
	Soubor	:	CLine.h
	Popis	:	Rasterizace usecky
	Autor	:	Jan Stalmach, stalmachjan@volny.cz 
	Obor	:	Informacni technologie, 2003-2004
	  
	Implementovany nasledujci algoritmy:

	Digital Differencial Analyser (DDA)
	Bresenhamuv linearni interpolator
	Xiaolin Wu Line Two-Step

---------------------------------------------------------------------------------*/

#ifndef _LINE_H
#define _LINE_H	

#include "CRaster.h"
#include "stopky.h"


/*----------------------------------------------
	Trida Cline pro rasterizaci usecky
------------------------------------------------*/
class CLine: public CRaster {

protected:

	Stopky *Casovac;

	float red,green,blue;

public:

	CLine(float r, float g, float b);

	~CLine() {}

	double DDA(int x0, int y0, int x1, int y1);
    double Bresenham(int x0, int y0, int x1, int y1);
	double TwoStep(int x0, int y0, int x1, int y1);

	void Set_RGB(float r, float g, float b);

};


#endif