/*----------------------------------------------------------------------------

  UNIVERZITA TOMASE BATI VE ZLINE
  FAKULTA TECHNOLOGICKA

  Demo aplikace pouziti rasterizacni knihovny pod OpenGL

  Jan Stalmach, IT, leto 2004

----------------------------------------------------------------------------*/


// Pouzite hlavickove soubory

#include <windows.h>					// Standartni knihovna windows
#include <gl/gl.h>						// Standartni OpenGL knihovna
#include <gl/glu.h>						// OpenGL utility
#include <stdio.h>						// Standartni vstupne-vystupni knihovna
#include "glut.h"						// Knihovna glut pro praci s okny


// Rasterizacni knihovna
#include "../CRaster.h"					
#include "../CLine.h"					// Knihovna grafickych algoritmu - kresleni car
#include "../CCurve.h"					// Knihovna grafickych algoritmu - kresleni krivek



/* DULEZITE ! -------------------------------------------------

  Pro fungovani dema je treba v souboru CRaster.h mit nastavene 
  spravne renderovaci rozhrani

  Promena RENDERER musi byt nastavena na OPENGL (0)

-- DULEZITE ! -----------------------------------------------*/


// Velikost okna aplikace
#define SIRKA 800
#define VYSKA 600


// Deklarace promenych
CLine  *Usecka = new CLine(1,0,0);
CCurve *Krivka = new CCurve(0,0,0,100);


/*--------------------------------------------
 Prekresli okno do spravnych pomeru stran
 ----------------------------------------------*/
void Reshape (int w, int h)
{
	glViewport(0, 0, w, h);		   // Transformace okno-format
    glMatrixMode(GL_PROJECTION);   // Prepne se na projekcni matici
    glLoadIdentity();
    glOrtho(0,w,0,h,1,-1);		   // 2D ortho projekce
	glMatrixMode(GL_MODELVIEW);
    glLoadIdentity();	
}


/*----------------------------- 
  Funkce cte tisknute klavesy
--------------------------------*/
void Klavesnice(unsigned char key, int x, int y)
{
   switch (key) {

   case 27: {           // Pri ESC skonci aplikaci
       
				exit(0); 	  
	    	    break;
		   };

	 default : break;
      };
}


/*------------------------------------
  Funkce zajistijici renderovani sceny
--------------------------------------*/
void Render(void)
{
	// Vycisti backbuffer a hloubkovy buffeer
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT); 

	// Nahraje identickou matici
	glLoadIdentity();

	// Vykresli usecku pomoci Bresenhamova algoritmu
	Usecka->Bresenham(150,500,300,300);
	
	bod A = bod(100,100,0);
	bod B = bod(150,350,0);
	bod C = bod(400,350,0);
	bod D = bod(450,100,0);

	// Vykresli Bezierovu kubiku
	Krivka->Bezierova_Kubika_Iterativne(A,B,C,D);

	// Prekresleni bufferu
    glutPostRedisplay();

	// Prohodi videobuffery
	glutSwapBuffers();
}


/*----------------------------
  Hlavni volana fce main()
-----------------------------*/
void main(int argc, char** argv)
{ 
   // Inicializuj glut
   glutInit(&argc, argv);

   // Pouzije doublebuffering, RGBA model a depthbuffer (z-buffer)
   glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGB);

   // Nastavi velikost okna aplikace
   glutInitWindowSize(SIRKA, VYSKA);

   // Nastavi pozici na monitoru
   glutInitWindowPosition(50, 50);
   
   // Vytvori renderovaci okno
   glutCreateWindow(TEXT("Priklad pouziti algoritmicke knihovny pod OpenGL"));	   
  
   // Parametry OpenGL
   glClearColor(1.0f, 1.0f, 1.0f, 1.0f);
  
   // Nasleduji call-back fce
   glutDisplayFunc(Render); 
   glutReshapeFunc(Reshape);
   glutKeyboardFunc(Klavesnice);
   
   // Hlavni smycka
   glutMainLoop(); 
} 


