/*---------------------------------------------------------------------------------

	>> INSTITUT INFORMACNICH TECHNOLOGII
	>> FAKULTA TECHNOLOGICKA
	>> UNIVERZITA TOMASE BATI VE ZLINE					       
 
	Soubor	:	CRasterizace.cpp
	Popis	:	Ukazka pouziti rasterizacni knohovny pod Win32 API GDI
			Urceno pro MS Visual 6.0
	Autor	:	Jan Stalmach, stalmachjan@volny.cz 
	Obor	:	Informacni technologie, 2004

---------------------------------------------------------------------------------*/ 

// Pouzite hlavickove soubory
#include <windows.h>

// Rasterizacni knihovna
#include "../CRaster.h"					
#include "../Cline.h"					// Knihovna grafickych algoritmu - kresleni car
#include "../CCurve.h"					// Knihovna grafickych algoritmu - kresleni krivek



/* DULEZITE ! -------------------------------------------------

  Pro fungovani dema je treba v souboru CRaster.h mit nastavene 
  spravne renderovaci rozhrani

  Promena RENDERER musi byt nastavena na WIN32API_GDI (1)

-- DULEZITE ! -----------------------------------------------*/



// Inicializace globalnich promenych

CLine  *Usecka = new CLine(1,0,0);
CCurve *Krivka = new CCurve(1,0,0,100);

// Ridici polygon Bezierovy kubiky
bod A = bod(100,100,0);
bod B = bod(150,350,0);
bod C = bod(400,350,0);
bod D = bod(450,100,0);


// Predbezna deklarace funkce
LRESULT CALLBACK WndProc (HWND, UINT, WPARAM, LPARAM);


/*-------------------------------------------------------------------------------
 Hlavni Win32 funkce

	registrace okna
	vytvoreni okna
	skok do smycky zprav
---------------------------------------------------------------------------------*/
int WINAPI WinMain (HINSTANCE hInstance, HINSTANCE hPrevInstance,
                    PSTR szCmdLine, int iCmdShow)
{
     static TCHAR szAppName[] = TEXT ("Demo pod Win32");
     HWND         hwnd ;
     MSG          msg ;
     WNDCLASS     wndclass ;
     
     wndclass.style         = CS_HREDRAW | CS_VREDRAW;
     wndclass.lpfnWndProc   = WndProc;
     wndclass.cbClsExtra    = 0;
     wndclass.cbWndExtra    = 0;
     wndclass.hInstance     = hInstance;
     wndclass.hIcon         = LoadIcon (NULL, IDI_APPLICATION);
     wndclass.hCursor       = LoadCursor (NULL, IDC_ARROW);
     wndclass.hbrBackground = (HBRUSH) GetStockObject (WHITE_BRUSH);
     wndclass.lpszMenuName  = NULL;
     wndclass.lpszClassName = szAppName;
          
     if (!RegisterClass (&wndclass))
     {
          MessageBox (NULL, TEXT ("Program vyaduje Windows NT!"), szAppName, MB_ICONERROR);
          return 0;
     }
     
     hwnd = CreateWindow (szAppName, TEXT ("Demonstrace pouit knihovny pod WIN32 API GDI"),
                          WS_OVERLAPPEDWINDOW,
                          CW_USEDEFAULT, CW_USEDEFAULT,
                          CW_USEDEFAULT, CW_USEDEFAULT,
                          NULL, NULL, hInstance, NULL);
    
     ShowWindow (hwnd, iCmdShow);
     UpdateWindow (hwnd);
     
     while (GetMessage (&msg, NULL, 0, 0))
     {
          TranslateMessage (&msg);
          DispatchMessage (&msg);
     }
     return msg.wParam;
}


/*-------------------------------------------------------------------------------
 Funkce pro zachytavani systemovych zprav
---------------------------------------------------------------------------------*/
LRESULT CALLBACK WndProc (HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
     static int		cxClient, cyClient;
	 HDC			hdc;
     PAINTSTRUCT	ps;
     
     switch (message)
     {
     case WM_SIZE:
          cxClient = LOWORD(lParam);
          cyClient = HIWORD(lParam);
          return 0 ;
       
     // Nejdulezitejsi cast !
     case WM_PAINT:

		  // Nejprve je treba priradit kreslici kontext
		  Usecka->hdc = hdc = BeginPaint(hwnd,&ps);

		  // Fialova barva
		  Usecka->barva = 0xFF00FF;

		  // Kresba usecky pomoci Bresenhamova algoritmu
	  	  Usecka->Bresenham(150,500,300,300);

		  // Zelena barva
		  Usecka->barva = 0x00FF00;

		  // Kresba usecky pomoci Two Step algoritmu
		  Usecka->TwoStep(10,50,270,500);

		  // Predame dal kreslici kontext
		  // Zde je nutno priradit kontext promene Cara, protoze krivku aproximujeme posloupnosti usecek !
		  Krivka->Cara->hdc = Usecka->hdc;
		  
		  // Modra barva
		  Krivka->Cara->barva = 0xFF0000;

		  // Vykresli Bezierovu kubiku
		  Krivka->Bezierova_Kubika_Iterativne(A,B,C,D);

		  EndPaint (hwnd, &ps);

		  return 0;
          
     case WM_DESTROY:
          PostQuitMessage (0);
          return 0;
     }
     return DefWindowProc (hwnd, message, wParam, lParam);
}
