/*-----------------------------------------------------------------------------
 
  UNIVERZITA TOMASE BATI VE ZLINE
  FAKULTA TECHNOLOGICKA
	
  Soubor : stopky.cpp
  Nazev  : Knihovna pro mereni casu pod Win32 [presnost tisiciny ms] 
           a pod multiplatformnim SDL [presnost ms]
  Autor  : Jan Stalmach, 2003-2004, stalmachjan@volny.cz
  Obor   : Informacni technologie

 ------------------------------------------------------------------------------*/

#ifndef _STOPKY_H	
#define _STOPKY_H		


/*----------------------------------------------
	Trida Stopky
------------------------------------------------*/
class Stopky 
{
public:

	Stopky();			// Konstruktor
	~Stopky() {}		// Destruktor

	// Promnn pro vpoet FPS a CPU period hodin
	unsigned int uiFps;							// Poet snmk za sekundu
	unsigned int uiMaxFps;						// Maximln hodnota FPS
	unsigned int uiCountTick;					// Poet takt CPU asovae
	unsigned int uiMinCountTick;				// Min poet takt CPU asovae
	unsigned int uiStartTick;					// Vstupn hodnota asovae (CPU period hodin) pro vpoet takt CPU asovae

	// Resetuje cas na 0
	void Reset();

	// Vrac as v milisekundch pi startu asovae 
	double GetTime() const;

	// Zastav asova
	virtual void Pause();

	// Znovu spust zastaven asova
	virtual void Unpause();

private:

	/* Frekvence casovace */
	__int64 i64Freq;

	/* casov rozlozeni */
	float  fResolutionTime;

	/* Performance counter timer variables for start times */
	__int64 i64TimerStart;

	/* Hodnota, kter udv jak velk asov sek bude zastaven asova */  
	int iPauseCount;
 
	/* Hodnota, kter udv hodnotu asovae, kdy dolo k zastaven asovae */ 
	double dPauseTime;

	// Start SDL casovace
	double sTime;
};


#endif	
